<?php
/**************************************************
  Coppermine 1.4.x Plugin - EnlargeIt! $VERSION$=2.15
  *************************************************
  Copyright (c) 2008 Timos-Welt (www.timos-welt.de)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ***************************************************/

define('IN_COPPERMINE', true);
define('DISPLAYIMAGE_PHP', true);
define('INDEX_PHP', true);
define('UPLOAD_PHP', true);

require('include/init.inc.php');

if (!USER_ID && $CONFIG['allow_unlogged_access'] == 0) {
    $redirect = $redirect . "login.php";
    header("Location: $redirect");
    exit();
}

$pos = $superCage->get->getInt('pos');

/** Hack added by tarique to prevent incorrect picture being seen on last view or last uploaded */

$pid = $superCage->get->getInt('pid');
$cat = $superCage->get->getInt('cat');

/** TODO: Add the code to handle date parameter  */
//$date = $superCage->get->getInt('cat');
if ($superCage->get->testAlpha('album')) {
    $album = $superCage->get->getAlpha('album');
} else {
    $album = $superCage->get->getInt('album');
}

/** get ajax call to thumb photo slideshow*/
$ajax_show = $superCage->get->getInt('ajax_show');

/** get AJAX call to run filmstrip */
$ajax_call = $superCage->get->getInt('ajax_call');

// attempt to fix topn images for keyworded albums
if ($cat < 0) {
    $result = cpg_db_query("SELECT category, title, aid, keyword, description, alb_password_hint FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid='" . (- $cat) . "'");
    if (mysql_num_rows($result) > 0) {
        $CURRENT_ALBUM_DATA = mysql_fetch_assoc($result);
        $CURRENT_ALBUM_KEYWORD = $CURRENT_ALBUM_DATA['keyword'];
    }
    mysql_free_result($result);
}

get_meta_album_set($cat);

if (!$superCage->get->keyExists('fullsize') && ($pos < 0 || $pid > 0)) {

    $pid = ($pos < 0) ? -$pos : $pid;
    
    if (!$album) {
        
        $result = cpg_db_query("SELECT aid FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE pid='$pid' $FORBIDDEN_SET LIMIT 1");

        if (mysql_num_rows($result) == 0) {
            // show password prompt if the file is in a password protected album and the user has access rights to that album
            $aid = mysql_result(cpg_db_query("SELECT aid FROM {$CONFIG['TABLE_PICTURES']} WHERE pid='$pid' LIMIT 1"), 0);
            if (cpg_pw_protected_album_access($aid) === 1) {
                $redirect = "thumbnails.php?album=".$aid;
                header("Location: $redirect");
            } else {
                cpg_die(ERROR, $lang_errors['non_exist_ap'], __FILE__, __LINE__);
            }
        }

        $row = mysql_fetch_assoc($result);
        mysql_free_result($result);
    }

    $album = (!$album) ? $row['aid'] : $album;
    
    // attempt to determine the position directly
    $pos = get_pic_pos($album, $pid);
    
    if ($pos === FALSE) {
    
        $pic_data = get_pic_data($album, $pic_count, $album_name, -1, -1, false);
        
        for ($pos = 0; $pic_data[$pos]['pid'] != $pid && $pos < $pic_count; $pos++);
        
        reset($pic_data);
        
        $CURRENT_PIC_DATA = $pic_data[$pos];
    
    } else {
    
        // load current pic details
        $pic_data = get_pic_data($album, $pic_count, $album_name, $pos, 1, false);
        $CURRENT_PIC_DATA = $pic_data[0];
  
        // load prev, next, start and end for the navbar
        if ($pos > 0) {
            $prev = get_pic_data($album, $pic_count, $album_name, $pos - 1, 1, false, 'pidonly');
            $pic_data[$pos - 1] = $prev[0];
        }
  
        if ($pos < ($pic_count -1)) {
            $next = get_pic_data($album, $pic_count, $album_name, $pos + 1, 1, false, 'pidonly');
            $pic_data[$pos + 1] = $next[0];
        }

        $start = get_pic_data($album, $pic_count, $album_name, 0, 1, false, 'pidonly');
        $pic_data[0] = $start[0];
     
        $end = get_pic_data($album, $pic_count, $album_name, $pic_count - 1, 1, false, 'pidonly');
        $pic_data[$pic_count - 1] = $end[0];
    }
} elseif (isset($pos) && is_numeric($pos)) {
    //$pic_data = get_pic_data($album, $pic_count, $album_name, $pos, 1, false);
    //We must get all the data here as well, otherwise the prev/next breaks.
    $pic_data = get_pic_data($album, $pic_count, $album_name, -1, -1, false);
 
    if ($pic_count == 0) {
        cpg_die(INFORMATION, $lang_errors['no_img_to_display'], __FILE__, __LINE__);
    } elseif (count($pic_data) == 0 && $pos >= $pic_count) {
        $pos = $pic_count - 1;
        $human_pos = $pos + 1;
        $pic_data = get_pic_data($album, $pic_count, $album_name, $pos, 1, false);
    }
 
    $CURRENT_PIC_DATA = $pic_data[$pos];
}


//      Histogram creation
//      Created by Anton Sparrius (Spaz) 6/9/05  anton_spaz@yahoo.com
//      Free to use and change, provided you keep these lines :)
//


                        
                        $enl_histpath = 'albums/'.$CURRENT_PIC_DATA['filepath'];
                        $enl_histimage = (is_file($enl_histpath.'normal_'.$CURRENT_PIC_DATA['filename'])) ? 'normal_'.$CURRENT_PIC_DATA['filename'] : $CURRENT_PIC_DATA['filename'];
                        $enl_histfile="hist_".substr($enl_histimage,0,strlen($enl_histimage)-4).".png";
                        //echo "path: ".$enl_histpath." image: ".$enl_histimage." hist_file: ".$enl_histfile;
                        if (file_exists('plugins/enlargeit/histcache/'.$pid.$enl_histfile)) {
                        header('Content-type: image/png');
                        readfile ('plugins/enlargeit/histcache/'.$pid.$enl_histfile);
                        } else {
                        $im=imagecreatefromjpeg($enl_histpath.$enl_histimage);
                        for($i=0;$i<imagesx($im);$i+=2)
                        {
                                for($j=0;$j<imagesy($im);$j++)
                                {
                                        $rrggbb=imagecolorsforindex ($im, imagecolorat($im,$i,$j));
                                        $r[$rrggbb['red']]+=1;
                                        $g[$rrggbb['green']]+=1;
                                        $b[$rrggbb['blue']]+=1;
                                }
                        }
                        for ($i=0;$i<256;$i++)
                        {
                                $max[$i]=($r[$i]+$g[$i]+$b[$i])/3;
                        }
                        $max_value=max($max)/150;
                        $m[0]=max($r);
                        $m[1]=max($b);
                        $m[2]=max($g);
                        $max_rgb=max($m)/150;

                        $im_out = imageCreate (284, 164);
                        $background = imageColorAllocate($im_out,100,100,110);
                        $box_fill   = imageColorAllocate($im_out,130,130,140);
                        $white=ImageColorAllocate($im_out,240,240,240);
                        $black=ImageColorAllocate($im_out,20,20,20);
                        $grey=ImageColorAllocate($im_out,200,200,200);
                        $red=ImageColorAllocate($im_out,255,0,0);
                        $green=ImageColorAllocate($im_out,0,200,0);
                        $blue=ImageColorAllocate($im_out,0,0,255);
                        $ry=107;
                        $gy=107;
                        $by=107;

                        imageFilledRectangle($im_out,13,6,270,158,$box_fill);

                        for($i=0;$i<256;$i++)
                        {
                                imageLine($im_out, $i+14, 157, $i+14, 157-($max[$i]/$max_value),$white);
                                imageLine($im_out, $i+13, $ry, $i+14, 157-($r[$i]/$max_rgb), $red);
                                imageLine($im_out, $i+13, $gy, $i+14, 157-($g[$i]/$max_rgb), $green);
                                imageLine($im_out, $i+13, $by, $i+14, 157-($b[$i]/$max_rgb), $blue);
                                $ry=157-($r[$i]/$max_rgb);
                                $gy=157-($g[$i]/$max_rgb);
                                $by=157-($b[$i]/$max_rgb);
                        }
                        imagePNG($im_out,'plugins/enlargeit/histcache/'.$pid.$enl_histfile);
                        imageDestroy($im);
                        imagedestroy($im_out);
                        $im=imagecreatefromPNG('plugins/enlargeit/histcache/'.$pid.$enl_histfile);
                        imagedestroy($im);
                        header('Content-type: image/png');
                        readfile ('plugins/enlargeit/histcache/'.$pid.$enl_histfile);
                        }

?>