<?php
/**************************************************
  Coppermine 1.4.x Plugin - EnlargeIt! $VERSION$=2.15
  *************************************************
  Copyright (c) 2008 Timos-Welt (www.timos-welt.de)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ***************************************************/

define('IN_COPPERMINE', true);
define('DISPLAYIMAGE_PHP', true);
define('INDEX_PHP', true);
//define('SMILIES_PHP', true);

require('include/init.inc.php');

if (!USER_ID && $CONFIG['allow_unlogged_access'] == 0) {
    $redirect = $redirect . "login.php";
    header("Location: $redirect");
    exit();
}




/** Main code  */
$pos = $superCage->get->getInt('pos');
$enl_img = $superCage->get->getRaw('enl_img');
/** Hack added by tarique to prevent incorrect picture being seen on last view or last uploaded */

$pid = $superCage->get->getInt('pid');
$cat = $superCage->get->getInt('cat');

/** TODO: Add the code to handle date parameter  */
//$date = $superCage->get->getInt('cat');
if ($superCage->get->testAlpha('album')) {
    $album = $superCage->get->getAlpha('album');
} else {
    $album = $superCage->get->getInt('album');
}

/** get ajax call to thumb photo slideshow*/
$ajax_show = $superCage->get->getInt('ajax_show');

/** get AJAX call to run filmstrip */
$ajax_call = $superCage->get->getInt('ajax_call');

// attempt to fix topn images for keyworded albums
if ($cat < 0) {
    $result = cpg_db_query("SELECT category, title, aid, keyword, description, alb_password_hint FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid='" . (- $cat) . "'");
    if (mysql_num_rows($result) > 0) {
        $CURRENT_ALBUM_DATA = mysql_fetch_assoc($result);
        $CURRENT_ALBUM_KEYWORD = $CURRENT_ALBUM_DATA['keyword'];
    }
    mysql_free_result($result);
}

get_meta_album_set($cat);

if (!$superCage->get->keyExists('fullsize') && ($pos < 0 || $pid > 0)) {

    $pid = ($pos < 0) ? -$pos : $pid;
    
    if (!$album) {
        
        $result = cpg_db_query("SELECT aid FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE pid='$pid' $FORBIDDEN_SET LIMIT 1");

        if (mysql_num_rows($result) == 0) {
            // show password prompt if the file is in a password protected album and the user has access rights to that album
            $aid = mysql_result(cpg_db_query("SELECT aid FROM {$CONFIG['TABLE_PICTURES']} WHERE pid='$pid' LIMIT 1"), 0);
            if (cpg_pw_protected_album_access($aid) === 1) {
                $redirect = "thumbnails.php?album=".$aid;
                header("Location: $redirect");
            } else {
                cpg_die(ERROR, $lang_errors['non_exist_ap'], __FILE__, __LINE__);
            }
        }

        $row = mysql_fetch_assoc($result);
        mysql_free_result($result);
    }

    $album = (!$album) ? $row['aid'] : $album;
    
    // attempt to determine the position directly
    $pos = get_pic_pos($album, $pid);
    
    if ($pos === FALSE) {
    
        $pic_data = get_pic_data($album, $pic_count, $album_name, -1, -1, false);
        
        for ($pos = 0; $pic_data[$pos]['pid'] != $pid && $pos < $pic_count; $pos++);
        
        reset($pic_data);
        
        $CURRENT_PIC_DATA = $pic_data[$pos];
    
    } else {
    
        // load current pic details
        $pic_data = get_pic_data($album, $pic_count, $album_name, $pos, 1, false);
        $CURRENT_PIC_DATA = $pic_data[0];
  
        // load prev, next, start and end for the navbar
        if ($pos > 0) {
            $prev = get_pic_data($album, $pic_count, $album_name, $pos - 1, 1, false, 'pidonly');
            $pic_data[$pos - 1] = $prev[0];
        }
  
        if ($pos < ($pic_count -1)) {
            $next = get_pic_data($album, $pic_count, $album_name, $pos + 1, 1, false, 'pidonly');
            $pic_data[$pos + 1] = $next[0];
        }

        $start = get_pic_data($album, $pic_count, $album_name, 0, 1, false, 'pidonly');
        $pic_data[0] = $start[0];
     
        $end = get_pic_data($album, $pic_count, $album_name, $pic_count - 1, 1, false, 'pidonly');
        $pic_data[$pic_count - 1] = $end[0];
    }
} elseif (isset($pos) && is_numeric($pos)) {
    //$pic_data = get_pic_data($album, $pic_count, $album_name, $pos, 1, false);
    //We must get all the data here as well, otherwise the prev/next breaks.
    $pic_data = get_pic_data($album, $pic_count, $album_name, -1, -1, false);
 
    if ($pic_count == 0) {
        cpg_die(INFORMATION, $lang_errors['no_img_to_display'], __FILE__, __LINE__);
    } elseif (count($pic_data) == 0 && $pos >= $pic_count) {
        $pos = $pic_count - 1;
        $human_pos = $pos + 1;
        $pic_data = get_pic_data($album, $pic_count, $album_name, $pos, 1, false);
    }
 
    $CURRENT_PIC_DATA = $pic_data[$pos];
}




$pid = $superCage->get->getInt('pid');

echo '<table cellspacing="1" style="width:100%;height:100%">';
echo '<tr>';
echo '<td colspan="2" class="enl_infotablehead" align="center"><b>'.$lang_rate_pic['rate_this_pic'].'</b><br />';
if ($CURRENT_PIC_DATA['votes'] > 0) echo sprintf($lang_picinfo['Rating'], $CURRENT_PIC_DATA['votes']).': '.round($CURRENT_PIC_DATA['pic_rating'] / 2000,2).'/5';
echo '</td>';
echo '</tr>';
echo '<tr><td class="enl_infotable" width="50%" align="right"><a href="javascript:;" title="'.$lang_rate_pic['great'].'" rel="nofollow"><img width="65" height="14" onclick="enl_ajaxfollow(this);" name="enl_rtepic.php?pic='.$pid.'&amp;rate=5&amp;enl_img='.$enl_img.'" src="plugins/enlargeit/rating/rating5.gif" border="0" alt="'.$lang_rate_pic['great'].'" /><br /></a></td><td class="enl_infotable" width="50%" align="left">'.$lang_rate_pic['great'].'</td></tr>';
echo '<tr><td class="enl_infotable" width="50%" align="right"><a href="javascript:;" title="'.$lang_rate_pic['excellent'].'" rel="nofollow"><img width="65" height="14" onclick="enl_ajaxfollow(this);" name="enl_rtepic.php?pic='.$pid.'&amp;rate=4&amp;enl_img='.$enl_img.'" src="plugins/enlargeit/rating/rating4.gif" border="0" alt="'.$lang_rate_pic['excellent'].'" /><br /></a></td><td class="enl_infotable" width="50%" align="left">'.$lang_rate_pic['excellent'].'</td></tr>';
echo '<tr><td class="enl_infotable" width="50%" align="right"><a href="javascript:;" title="'.$lang_rate_pic['good'].'" rel="nofollow"><img width="65" height="14" onclick="enl_ajaxfollow(this);" name="enl_rtepic.php?pic='.$pid.'&amp;rate=3&amp;enl_img='.$enl_img.'" src="plugins/enlargeit/rating/rating3.gif" border="0" alt="'.$lang_rate_pic['good'].'" /><br /></a></td><td class="enl_infotable" width="50%" align="left">'.$lang_rate_pic['good'].'</td></tr>';
echo '<tr><td class="enl_infotable" width="50%" align="right"><a href="javascript:;" title="'.$lang_rate_pic['fair'].'" rel="nofollow"><img width="65" height="14" onclick="enl_ajaxfollow(this);" name="enl_rtepic.php?pic='.$pid.'&amp;rate=2&amp;enl_img='.$enl_img.'" src="plugins/enlargeit/rating/rating2.gif" border="0" alt="'.$lang_rate_pic['fair'].'" /><br /></a></td><td class="enl_infotable" width="50%" align="left">'.$lang_rate_pic['fair'].'</td></tr>';
echo '<tr><td class="enl_infotable" width="50%" align="right"><a href="javascript:;" title="'.$lang_rate_pic['poor'].'" rel="nofollow"><img width="65" height="14" onclick="enl_ajaxfollow(this);" name="enl_rtepic.php?pic='.$pid.'&amp;rate=1&amp;enl_img='.$enl_img.'" src="plugins/enlargeit/rating/rating1.gif" border="0" alt="'.$lang_rate_pic['poor'].'" /><br /></a></td><td class="enl_infotable" width="50%" align="left">'.$lang_rate_pic['poor'].'</td></tr>';
echo '<tr><td class="enl_infotable" width="50%" align="right"><a href="javascript:;" title="'.$lang_rate_pic['rubbish'].'" rel="nofollow"><img width="65" height="14" onclick="enl_ajaxfollow(this);" name="enl_rtepic.php?pic='.$pid.'&amp;rate=0&amp;enl_img='.$enl_img.'" src="plugins/enlargeit/rating/rating0.gif" border="0" alt="'.$lang_rate_pic['rubbish'].'" /><br /></a></td><td class="enl_infotable" width="50%" align="left">'.$lang_rate_pic['rubbish'].'</td></tr>';
echo '</table>';


ob_end_flush();

?>